"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ParticipantInterpretationFlags(ProtocolElement):
    """
    Interpretation flags at the participant level
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "SampleId",
        "interpretationFlag",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "interpretationFlag": reports_6_1_1.InterpretationFlags,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "org.gel.models.report.avro.InterpretationFlags": reports_6_1_1.InterpretationFlags,
            "org.gel.models.report.avro.ParticipantInterpretationFlags": reports_6_1_1.ParticipantInterpretationFlags,
        }

    __slots__ = [
        "SampleId",
        "interpretationFlag",
        "additionalDescription",
        "participantId",
    ]

    def __init__(
        self,
        SampleId,
        interpretationFlag,
        additionalDescription=None,
        participantId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_1.ParticipantInterpretationFlags model.

        :param SampleId:
            Sample Id fron which this flag was reported
        :type SampleId: str
        :param interpretationFlag:
            The interpretation flag
        :type interpretationFlag: InterpretationFlags
        :param additionalDescription:
            The description for the flag
        :type additionalDescription: None | str
        :param participantId:
            Participant Id as appeared in the pedigree
        :type participantId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.1"
